export declare function createStyle(doc: Document, cssText: string): HTMLStyleElement;
export declare function createIFrame(parent?: HTMLElement): HTMLIFrameElement;
export declare type PrintdLaunchPrint = (window: Window) => void;
export interface PrintdCallbackArgs {
    /** Iframe contentWindow reference */
    window: Window;
    /** Iframe contentDocument reference */
    document: Document;
    /** HTMLElement copy reference */
    element: HTMLElement;
    /** Launch the printing dialog */
    launchPrint: PrintdLaunchPrint;
}
export declare type PrintdCallback = (args: PrintdCallbackArgs) => void;
export default class Printd {
    private readonly parent;
    private readonly iframe;
    constructor(parent?: HTMLElement);
    getIFrame(): HTMLIFrameElement;
    print(el: HTMLElement, cssText?: string, callback?: PrintdCallback): void;
    private launchPrint;
}
export { Printd };
